﻿// <auto-generated />
using System;
using AuctionManagement.Persistence.EF;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;

namespace AuctionManagement.Persistence.EF.Migrations
{
    [DbContext(typeof(AuctionContext))]
    [Migration("20200415181014_init")]
    partial class init
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "3.1.3")
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("Relational:Sequence:.AuctionSequence", "'AuctionSequence', '', '1', '1', '', '', 'Int32', 'False'")
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("AuctionManagement.Domain.Model.Auctions.Auction", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<DateTime>("CreateDateTime")
                        .HasColumnType("datetime2");

                    b.Property<DateTime>("EndDateTime")
                        .HasColumnType("datetime2");

                    b.Property<long>("ProductId")
                        .HasColumnType("bigint");

                    b.HasKey("Id");

                    b.ToTable("Auction");
                });

            modelBuilder.Entity("AuctionManagement.Persistence.EF.SequenceId", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.HasKey("Id");

                    b.ToTable("SequenceIds");
                });

            modelBuilder.Entity("Framework.Core.Events.DomainEvent", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier");

                    b.Property<long?>("AuctionId")
                        .HasColumnType("bigint");

                    b.Property<DateTime>("PublishDateTime")
                        .HasColumnType("datetime2");

                    b.HasKey("Id");

                    b.HasIndex("AuctionId");

                    b.ToTable("DomainEvent");
                });

            modelBuilder.Entity("AuctionManagement.Domain.Model.Auctions.Auction", b =>
                {
                    b.OwnsMany("AuctionManagement.Domain.Model.Auctions.AuctionDetail", "AuctionDetails", b1 =>
                        {
                            b1.Property<long>("AuctionId")
                                .HasColumnType("bigint");

                            b1.Property<int>("Id")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<string>("Name")
                                .HasColumnType("nvarchar(max)");

                            b1.HasKey("AuctionId", "Id");

                            b1.ToTable("AuctionDetail");

                            b1.WithOwner()
                                .HasForeignKey("AuctionId");
                        });

                    b.OwnsOne("AuctionManagement.Domain.Model.Auctions.Bid", "WinningBid", b1 =>
                        {
                            b1.Property<long>("AuctionId")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("bigint")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<long>("BidderId")
                                .HasColumnType("bigint");

                            b1.Property<DateTime>("CreateDateTime")
                                .HasColumnType("datetime2");

                            b1.HasKey("AuctionId");

                            b1.ToTable("Auction");

                            b1.WithOwner()
                                .HasForeignKey("AuctionId");

                            b1.OwnsOne("AuctionManagement.Domain.Model.Shared.Money", "OfferedAmount", b2 =>
                                {
                                    b2.Property<long>("BidAuctionId")
                                        .ValueGeneratedOnAdd()
                                        .HasColumnType("bigint")
                                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                                    b2.Property<long>("Amount")
                                        .HasColumnType("bigint");

                                    b2.Property<string>("Currency")
                                        .IsRequired()
                                        .HasColumnType("nvarchar(max)");

                                    b2.HasKey("BidAuctionId");

                                    b2.ToTable("Auction");

                                    b2.WithOwner()
                                        .HasForeignKey("BidAuctionId");
                                });
                        });

                    b.OwnsOne("AuctionManagement.Domain.Model.Auctions.Participant", "Seller", b1 =>
                        {
                            b1.Property<long>("AuctionId")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("bigint")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<long>("Id")
                                .HasColumnType("bigint");

                            b1.Property<string>("Status")
                                .IsRequired()
                                .HasColumnType("nvarchar(max)");

                            b1.HasKey("AuctionId");

                            b1.ToTable("Auction");

                            b1.WithOwner()
                                .HasForeignKey("AuctionId");
                        });

                    b.OwnsOne("AuctionManagement.Domain.Model.Shared.Money", "StartingPrice", b1 =>
                        {
                            b1.Property<long>("AuctionId")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("bigint")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<long>("Amount")
                                .HasColumnType("bigint");

                            b1.Property<string>("Currency")
                                .IsRequired()
                                .HasColumnType("nvarchar(max)");

                            b1.HasKey("AuctionId");

                            b1.ToTable("Auction");

                            b1.WithOwner()
                                .HasForeignKey("AuctionId");
                        });
                });

            modelBuilder.Entity("Framework.Core.Events.DomainEvent", b =>
                {
                    b.HasOne("AuctionManagement.Domain.Model.Auctions.Auction", null)
                        .WithMany("UncommittedEvents")
                        .HasForeignKey("AuctionId");
                });
#pragma warning restore 612, 618
        }
    }
}
